package session03;

import java.util.Arrays;

class SharedData {
	public static void main(String[] args) {
		parameterWay();
		finalWay();
	}

	public static void finalWay() {
		final int N = 5;
		// The +25 is a guess.
		final int[] shared = new int[N + 25];
		Thread[] threads = new Thread[N];
		
		for (int i = 0; i < N; i++) {
			Thread thread = new Thread() {
				@Override
				public void run() {
					int id = (int) Thread.currentThread().getId();
					shared[id] = id;
				}
			};
			threads[i] = thread;
			thread.start();
		}

		for (int i = 0; i < N; i++) {
			try {
				threads[i].join();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

		System.out.println(Arrays.toString(shared));
	}

	public static void parameterWay() {
		final int N = 5;
		// The +25 is a guess.
		int[] shared = new int[N + 25];
		Thread[] threads = new Thread[N];

		for (int i = 0; i < N; i++) {
			Thread thread = new ThreadWithParams(shared);
			threads[i] = thread;
			thread.start();
		}

		for (int i = 0; i < N; i++) {
			try {
				threads[i].join();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		
		System.out.println(Arrays.toString(shared));
	}

}

class ThreadWithParams extends Thread {
	private int[] data;
	
	public ThreadWithParams(int[] data) {
		this.data = data;
	}

	@Override
	public void run() {
		int id = (int) Thread.currentThread().getId();
		data[id] = id;
	}
}

// Qs:
// what if we moved `System.out.println(Arrays.toString(shared));` above the
// joins?
